//---------------------------------------------------------------------------
#define WIN32

//#include <vcl.h>
#pragma hdrstop

#include "Desenha.h"
#include <GL/glut.h>
#include <stdio.h>
#pragma package(smart_init)

     void drawSquare( int x, int y);
     void myReshape(int w, int h);
     void myinit();
     void display();
     void refresh();
     int arg_c;
     char **arg_v;
     int wh, ww; // initial window size
     float size; // half side length of square
     int *vet_x, *vet_y; // vetores com as coordenadas das cidades
     int n_cidades; // numero de cidades
     int *solucao;  // vertor solucao do problema
     float menor_x, menor_y, maior_x, maior_y;

__fastcall Desenha::Desenha(bool CreateSuspended, int ac, char** av, int *sol, int *v_x, int *v_y, int n)
     : TThread(CreateSuspended)
{
     n_cidades = n;
     arg_c = ac;
     arg_v = av;
     wh = 500;
     ww = 500;
     size = 0.01;
     vet_x = v_x;
     vet_y = v_y;
     solucao = sol;
     menor_x = menor_y = INT_MAX;
     maior_x = maior_y = 0;
}
//---------------------------------------------------------------------------
void __fastcall Desenha::Execute()
{
     //---- Place thread code here ----
   glutInit(&arg_c,arg_v);
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);
   glutInitWindowSize(ww,wh);
   glutCreateWindow("Problema do Caixeiro Viajante");
   glutDisplayFunc(display);
   glutIdleFunc(refresh);

   for (int i = 0; i < n_cidades; i++){
          if ( vet_x[i] < menor_x)
               menor_x = vet_x[i];
          if ( vet_x[i] > maior_x)
               maior_x = vet_x[i];
          if ( vet_y[i] < menor_y)
               menor_y = vet_y[i];
          if ( vet_y[i] > maior_y)
               maior_y = vet_y[i];
   }
//   printf ("\nmenor_x = %f  menor_y = %f\n",menor_x,menor_y);
//   printf ("maior_x = %f  maior_y = %f\n",maior_x,maior_y);

   myinit();
   glutReshapeFunc(myReshape);
   glutMainLoop();
//   printf("vou sair do loop od OpenGL...\n");

}

void Desenha::exibe(){
     glutPostRedisplay();
     glFlush();
}

void refresh(){
     Sleep(50);
     display();
     glFlush();
}
//---------------------------------------------------------------------------

void drawSquare( float x, float y){
//   y -= wh;
   glColor3ub((char) rand() % 256, (char) rand() % 256, (char) rand() % 256);
   glBegin(GL_POLYGON);
      glVertex2f(x + size, y + size);
      glVertex2f(x - size, y + size);
      glVertex2f(x - size, y - size);
      glVertex2f(x + size, y - size);
   glEnd();
}

void myReshape(int w, int h){
// adjust clipping box
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   glOrtho(0.0, (GLdouble) w, 0.0, (GLdouble) h, 0.0, 0.0);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();

// adjust viewport and clear
   glViewport(0, 0, w, h);
   glClearColor(0.0, 0.0, 0.0, 1.0);
   glClear(GL_COLOR_BUFFER_BIT);
   display();
   glFlush();

// set global size for use by drawing routine
   ww = w;
   wh = h;
}// myReshape

void myinit(){
   glViewport(0,0, ww, wh);

/* Pick 2D clipping window to match size of X window
This choice avoids having to scale object coordinates
each time window is resized */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   glOrtho(0.0, (GLdouble) ww, 0.0, (GLdouble) wh, 0.0, 0.0);

/* set clear color to white and clear window */
   glClearColor(0.0, 0.0, 0.0, 1.0);
   glClear(GL_COLOR_BUFFER_BIT);
   glFlush();
}//myinit

void display(){
     /* Desenha as cidades na tela */
     glClearColor(1.0,1.0,1.0,1.0);
     glClear(GL_COLOR_BUFFER_BIT);
     glColor3f(0.0, 0.0, 0.0);
     for (int i = 0; i < n_cidades; i++){
          float x = ((vet_x[i] - menor_x) / (maior_x - menor_x)) * 2 - 1;
          float y = ((vet_y[i] - menor_y) / (maior_y - menor_y)) * 2 - 1;
//          printf("x = %f , y = %f\n", x, y);
          drawSquare(x,y);
     }
     for (int i = 0; i < n_cidades - 1; i++){
          float x1 = ((vet_x[solucao[i]  ] - menor_x) / (maior_x - menor_x)) * 2 - 1;
          float y1 = ((vet_y[solucao[i]  ] - menor_y) / (maior_y - menor_y)) * 2 - 1;
          float x2 = ((vet_x[solucao[i+1]] - menor_x) / (maior_x - menor_x)) * 2 - 1;
          float y2 = ((vet_y[solucao[i+1]] - menor_y) / (maior_y - menor_y)) * 2 - 1;
          glColor3f(1.0,0.0,0.0);
          glBegin(GL_LINES);
               glVertex2f(x1,y1);
               glVertex2f(x2,y2);
          glEnd();
     }
     glFlush();
}
